require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_I386_PMAP_H_)) {
    eval 'sub _I386_PMAP_H_ () {1;}' unless defined(&_I386_PMAP_H_);
    require 'machine/cpufunc.ph';
    require 'machine/pte.ph';
    require 'machine/segments.ph';
    require 'uvm/uvm_pglist.ph';
    require 'uvm/uvm_object.ph';
    eval 'sub PDSLOT_PTE () {(( &KERNBASE/ &NBPD)-2);}' unless defined(&PDSLOT_PTE);
    eval 'sub PDSLOT_KERN () {( &KERNBASE/ &NBPD);}' unless defined(&PDSLOT_KERN);
    eval 'sub PDSLOT_APTE () {(1022);}' unless defined(&PDSLOT_APTE);
    unless(defined(&NKPTP)) {
	eval 'sub NKPTP () {8;}' unless defined(&NKPTP);
    }
    eval 'sub NKPTP_MIN () {4;}' unless defined(&NKPTP_MIN);
    eval 'sub PG_W () { &PG_AVAIL1;}' unless defined(&PG_W);
    eval 'sub PG_PVLIST () { &PG_AVAIL2;}' unless defined(&PG_PVLIST);
    eval 'sub PG_X () { &PG_AVAIL3;}' unless defined(&PG_X);
    if(defined(&_KERNEL)) {
	eval 'sub pm_lock () { ($pm_obj->{vmobjlock});}' unless defined(&pm_lock);
	eval 'sub PMF_USER_LDT () {0x1;}' unless defined(&PMF_USER_LDT);
	eval 'sub PVE_PER_PVPAGE () {(( &NBPG - $sizeof{\'struct pv_page_info\'}) / $sizeof{\'struct pv_entry\'});}' unless defined(&PVE_PER_PVPAGE);
	eval 'sub PMAP_EXCLUDE_DECLS () {1;}' unless defined(&PMAP_EXCLUDE_DECLS);
	eval 'sub pmap_kernel () {
	    eval q(( &kernel_pmap_store));
	}' unless defined(&pmap_kernel);
	eval 'sub pmap_resident_count {
	    my($pmap) = @_;
    	    eval q((($pmap)-> ($pm_stats->{resident_count})));
	}' unless defined(&pmap_resident_count);
	eval 'sub pmap_update {
	    my($pm) = @_;
    	    eval q();
	}' unless defined(&pmap_update);
	eval 'sub pmap_clear_modify {
	    my($pg) = @_;
    	    eval q( &pmap_change_attrs($pg, 0,  &PG_M));
	}' unless defined(&pmap_clear_modify);
	eval 'sub pmap_clear_reference {
	    my($pg) = @_;
    	    eval q( &pmap_change_attrs($pg, 0,  &PG_U));
	}' unless defined(&pmap_clear_reference);
	eval 'sub pmap_copy {
	    my($DP,$SP,$D,$L,$S) = @_;
    	    eval q();
	}' unless defined(&pmap_copy);
	eval 'sub pmap_is_modified {
	    my($pg) = @_;
    	    eval q( &pmap_test_attrs($pg,  &PG_M));
	}' unless defined(&pmap_is_modified);
	eval 'sub pmap_is_referenced {
	    my($pg) = @_;
    	    eval q( &pmap_test_attrs($pg,  &PG_U));
	}' unless defined(&pmap_is_referenced);
	eval 'sub pmap_phys_address {
	    my($ppn) = @_;
    	    eval q( &ptoa($ppn));
	}' unless defined(&pmap_phys_address);
	eval 'sub pmap_valid_entry {
	    my($E) = @_;
    	    eval q((($E) &  &PG_V));
	}' unless defined(&pmap_valid_entry);
	eval 'sub pmap_proc_iflush {
	    my($p,$va,$len) = @_;
    	    eval q();
	}' unless defined(&pmap_proc_iflush);
	eval 'sub pmap_unuse_final {
	    my($p) = @_;
    	    eval q();
	}' unless defined(&pmap_unuse_final);
	if(defined(&SMALL_KERNEL)) {
	    eval 'sub pmap_pte_set_86 () { &pmap_pte_set;}' unless defined(&pmap_pte_set_86);
	    eval 'sub pmap_pte_setbits_86 () { &pmap_pte_setbits;}' unless defined(&pmap_pte_setbits_86);
	    eval 'sub pmap_pte_bits_86 () { &pmap_pte_bits;}' unless defined(&pmap_pte_bits_86);
	    eval 'sub pmap_pte_paddr_86 () { &pmap_pte_paddr;}' unless defined(&pmap_pte_paddr_86);
	    eval 'sub pmap_change_attrs_86 () { &pmap_change_attrs;}' unless defined(&pmap_change_attrs_86);
	    eval 'sub pmap_enter_86 () { &pmap_enter;}' unless defined(&pmap_enter_86);
	    eval 'sub pmap_extract_86 () { &pmap_extract;}' unless defined(&pmap_extract_86);
	    eval 'sub pmap_growkernel_86 () { &pmap_growkernel;}' unless defined(&pmap_growkernel_86);
	    eval 'sub pmap_page_remove_86 () { &pmap_page_remove;}' unless defined(&pmap_page_remove_86);
	    eval 'sub pmap_remove_86 () { &pmap_remove;}' unless defined(&pmap_remove_86);
	    eval 'sub pmap_test_attrs_86 () { &pmap_test_attrs;}' unless defined(&pmap_test_attrs_86);
	    eval 'sub pmap_unwire_86 () { &pmap_unwire;}' unless defined(&pmap_unwire_86);
	    eval 'sub pmap_write_protect_86 () { &pmap_write_protect;}' unless defined(&pmap_write_protect_86);
	    eval 'sub pmap_pinit_pd_86 () { &pmap_pinit_pd;}' unless defined(&pmap_pinit_pd_86);
	    eval 'sub pmap_zero_phys_86 () { &pmap_zero_phys;}' unless defined(&pmap_zero_phys_86);
	    eval 'sub pmap_zero_page_uncached_86 () { &pmap_zero_page_uncached;}' unless defined(&pmap_zero_page_uncached_86);
	    eval 'sub pmap_copy_page_86 () { &pmap_copy_page;}' unless defined(&pmap_copy_page_86);
	    eval 'sub pmap_try_steal_pv_86 () { &pmap_try_steal_pv;}' unless defined(&pmap_try_steal_pv_86);
	} else {
	    eval 'sub pmap_pte_set () {(* &pmap_pte_set_p);}' unless defined(&pmap_pte_set);
	    eval 'sub pmap_pte_setbits () {(* &pmap_pte_setbits_p);}' unless defined(&pmap_pte_setbits);
	    eval 'sub pmap_pte_bits () {(* &pmap_pte_bits_p);}' unless defined(&pmap_pte_bits);
	    eval 'sub pmap_pte_paddr () {(* &pmap_pte_paddr_p);}' unless defined(&pmap_pte_paddr);
	    eval 'sub pmap_change_attrs () {(* &pmap_change_attrs_p);}' unless defined(&pmap_change_attrs);
	    eval 'sub pmap_enter () {(* &pmap_enter_p);}' unless defined(&pmap_enter);
	    eval 'sub pmap_extract () {(* &pmap_extract_p);}' unless defined(&pmap_extract);
	    eval 'sub pmap_growkernel () {(* &pmap_growkernel_p);}' unless defined(&pmap_growkernel);
	    eval 'sub pmap_page_remove () {(* &pmap_page_remove_p);}' unless defined(&pmap_page_remove);
	    eval 'sub pmap_remove () {(* &pmap_remove_p);}' unless defined(&pmap_remove);
	    eval 'sub pmap_test_attrs () {(* &pmap_test_attrs_p);}' unless defined(&pmap_test_attrs);
	    eval 'sub pmap_unwire () {(* &pmap_unwire_p);}' unless defined(&pmap_unwire);
	    eval 'sub pmap_write_protect () {(* &pmap_write_protect_p);}' unless defined(&pmap_write_protect);
	    eval 'sub pmap_pinit_pd () {(* &pmap_pinit_pd_p);}' unless defined(&pmap_pinit_pd);
	    eval 'sub pmap_zero_phys () {(* &pmap_zero_phys_p);}' unless defined(&pmap_zero_phys);
	    eval 'sub pmap_zero_page_uncached () {(* &pmap_zero_page_uncached_p);}' unless defined(&pmap_zero_page_uncached);
	    eval 'sub pmap_copy_page () {(* &pmap_copy_page_p);}' unless defined(&pmap_copy_page);
	    eval 'sub pmap_try_steal_pv () {(* &pmap_try_steal_pv_p);}' unless defined(&pmap_try_steal_pv);
	}
	eval 'sub PMAP_GROWKERNEL () {1;}' unless defined(&PMAP_GROWKERNEL);
	eval 'sub PMAP_PAGEIDLEZERO {
	    my($pg) = @_;
    	    eval q( &pmap_zero_page_uncached( &VM_PAGE_TO_PHYS($pg)));
	}' unless defined(&PMAP_PAGEIDLEZERO);
	if(defined( &I386_CPU)) {
	}
	if(defined( &I386_CPU)) {
	}
	if(defined( &USER_LDT)) {
	    eval 'sub PMAP_FORK () {1;}' unless defined(&PMAP_FORK);
	}
    }
}
1;
